diff -Nur irc2.10.3p7/ircd/s_misc.c irc2.10.3p7+hemp2+DK+B5/ircd/s_misc.c
--- irc2.10.3p7/ircd/s_misc.c	Sun May  9 22:20:33 2004
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_misc.c	Tue May 11 15:25:04 2004
@@ -370,7 +370,11 @@
 	    {
 		if (sptr->flags & FLAGS_KILLED)
 		    {
+#ifdef LOCAL_REJECTIONS_ONLY
+			sendto_flag(SCH_NOTICE, "Killed: %s.",
+#else
 			sendto_flag(SCH_LOCAL, "Killed: %s.",
+#endif
 				    get_client_name(sptr, TRUE));
 			sptr->exitc = EXITC_KILL;
 		    }
@@ -386,6 +390,11 @@
 			sendto_flog(sptr, NULL, sptr->user->username,
 				    sptr->user->host);
 # endif
+#ifdef CLIENTS_CHANNEL
+			sendto_flag(SCH_CLIENTS, "Client exiting: %s was %s from %s reason: %s",
+				sptr->name,sptr->user->username,sptr->user->host,comment);
+
+#endif
 		    }
 		else if (sptr->exitc != EXITC_REF && sptr->exitc != EXITC_AREF)
 		    {
@@ -409,15 +418,43 @@
 			else
 				istat.is_unknown--;
 
-		      if (cptr != NULL && sptr != cptr)
-			sendto_one(sptr, "ERROR :Closing Link: %s %s (%s)",
-				   get_client_name(sptr,FALSE),
-				   cptr->name, comment);
-		      else
-			sendto_one(sptr, "ERROR :Closing Link: %s (%s)",
-				   get_client_name(sptr,FALSE), comment);
-
-		      if (sptr->auth != sptr->username)
+			if (istat.is_myclnt % CLCHNO == 0 &&
+				istat.is_myclnt != istat.is_l_myclnt)
+			{
+				sendto_flag(SCH_NOTICE,
+					"Local %screase from %d to %d clients "
+					"in %d seconds",
+					istat.is_myclnt > istat.is_l_myclnt ?
+					"in" : "de", istat.is_l_myclnt,
+					istat.is_myclnt,
+					timeofday - istat.is_l_myclnt_t);
+				istat.is_l_myclnt_t = timeofday;
+				istat.is_l_myclnt = istat.is_myclnt;
+			}
+#ifdef DELAY_CLOSE
+	                if (cptr && cptr->user && (cptr->user->flags
+						& FLAGS_BADBOY))
+               		{ 
+                           SPRINTF(cptr->buffer, "ERROR :Closing Link: %s (%s)",
+                           get_client_name(sptr,FALSE), comment);
+                        }
+                        else
+#endif
+		        {
+		        	if (cptr != NULL && sptr != cptr)
+				{
+					sendto_one(sptr, "ERROR :Closing Link: %s %s (%s)",
+				   	get_client_name(sptr,FALSE),
+				   	cptr->name, comment);
+				}
+		      		else
+				{
+					sendto_one(sptr, "ERROR :Closing Link: %s (%s)",
+				   	get_client_name(sptr,FALSE), comment);
+
+		    		}
+			}
+		        if (sptr->auth != sptr->username)
 			  {
 			    istat.is_authmem -= strlen(sptr->auth) + 1;
 			    istat.is_auth -= 1;
@@ -504,6 +541,15 @@
 				    }
 			    }
 		    } /* If (IsServer(sptr)) */
+#ifdef SPLIT_HANDLE
+		if ((istat.is_user[0] + istat.is_user[1]) < SPLIT_USERS || istat.is_eobservers < SPLIT_SERV)
+		{
+			if (!iconf.split)
+			{
+				check_split();
+			}
+		}
+#endif
 	    } /* if (MyConnect(sptr) || (sptr->flags & FLAGS_HELD)) */
 
  	if (IsServer(sptr) && GotDependantClient(sptr))
@@ -531,6 +577,16 @@
  			acptr->flags |= flags;
 			exit_one_client(cptr, acptr, &me, comment1);
  		}
+#ifdef SPLIT_HANDLE
+		if ((istat.is_user[0] + istat.is_user[1]) < SPLIT_USERS || istat.is_eobservers < SPLIT_SERV)
+		{
+			if (!iconf.split)
+			{
+				check_split();
+			}
+		}
+#endif
+
  	}
  	
 	/*
@@ -585,6 +641,15 @@
 	}
 	
 	exit_one_client(cptr, sptr, from, (*comment1) ? comment1 : comment);
+#ifdef SPLIT_HANDLE
+		if ((istat.is_user[0] + istat.is_user[1]) < SPLIT_USERS || istat.is_eobservers < SPLIT_SERV)
+		{
+			if (!iconf.split)
+			{
+				check_split();
+			}
+		}
+#endif
 	return cptr == sptr ? FLUSH_BUFFER : 0;
     }
 
@@ -612,13 +677,65 @@
 			    "ERROR: tried to exit me! : %s", comment);
 		return;	/* ...must *never* exit self!! */
 	    }
-	else if (IsServer(sptr)) {
+	else if (IsServer(sptr)) 
+	{
+		Link *lpu,**tmp;
+		aClient *auptr;
+		int dcnt = 0;
+
+
 	 /*
 	 ** Old sendto_serv_but_one() call removed because we now
 	 ** need to send different names to different servers
 	 ** (domain name matching)
 	 */
 		istat.is_serv--;
+#ifdef SPLIT_HANDLE
+		if (!IsBurst(sptr))
+		{
+			istat.is_eobservers--;
+		}
+#endif
+	/* we have also remove the server from ->down */
+		auptr = find_client(sptr->serv->up,NULL);
+		/* hmm.. if it doesn't exist, it means it squitted before */
+		if (auptr)
+		{
+			lpu = auptr->serv->down;
+			if (lpu)
+			{
+				dcnt = --lpu->flags;
+			}
+			for (tmp = &(auptr->serv->down); (lpu = *tmp); tmp = &lpu->next)
+			{
+				if (lpu->value.cptr == sptr)
+				{
+					*tmp = lpu->next;
+					free_link(lpu);
+					break;
+				}
+			}
+			if (auptr->serv->down)
+			{
+					auptr->serv->down->flags = dcnt;
+			}
+		}
+		/* and free my downlinks. The squit code is SOOO broken btw */
+		if (sptr->serv->down)
+		{
+			Link *lp2;
+			lp2 = sptr->serv->down;
+			while (lp2)
+			{
+				lpu = lp2;
+				lp2 = lp2->next;
+				free_link(lpu);
+			}
+			sptr->serv->down = NULL;
+		}
+#ifdef EXTRA_STATISTICS
+		save_server_max(sptr->name,sptr->serv->usermax);
+#endif
 	 	for (i = fdas.highest; i >= 0; i--)
 		    {
 			Reg	aConfItem *aconf;
@@ -704,11 +821,21 @@
 		if (sptr->user)
 		    {
 			if (IsInvisible(sptr))
+			{
 				istat.is_user[1]--;
-			else
-				istat.is_user[0]--;
+				sptr->user->servp->usercnt[1]--;
+			}
+                        else
+                        {
+                                sptr->user->servp->usercnt[0]--;
+                                istat.is_user[0]--;
+                        }
+
 			if (IsAnOper(sptr))
+			{
 				istat.is_oper--;
+				sptr->user->servp->usercnt[2]--;
+			}
 			sendto_common_channels(sptr, ":%s QUIT :%s",
 						sptr->name, comment);
 
@@ -753,6 +880,8 @@
 			add_history(sptr, (sptr == cptr) ? &me : NULL);
 #endif
 			off_history(sptr);
+			del_from_hostname_hash_table(sptr->user->host,sptr->user);
+
 		    }
 	    }
 	else if (sptr->name[0] && IsService(sptr))
@@ -833,16 +962,33 @@
 	istat.is_serv = 1;
 	istat.is_localc = 1;	/* &me */
 	bzero((char *)&ircst, sizeof(ircst));
+
+	bzero((char *)&iconf, sizeof(iconf));
+	iconf.aconnect = 1;
+	iconf.split = 1;
+#ifdef DELAY_ACCEPT
+	iconf.caccept = 2;
+#endif
 }
 
+#ifdef	EXTRA_STATISTICS
+void	tstats(cptr, name, level)
+aClient	*cptr;
+char	*name;
+int	level;
+#else
 void	tstats(cptr, name)
 aClient	*cptr;
 char	*name;
+#endif
 {
 	Reg	aClient	*acptr;
 	Reg	int	i;
 	Reg	struct stats	*sp;
 	struct	stats	tmp;
+#ifdef	EXTRA_STATISTICS
+	Reg     time_t  now;
+#endif
 
 	sp = &tmp;
 	bcopy((char *)ircstp, (char *)sp, sizeof(*sp));
@@ -892,6 +1038,173 @@
 			sp->is_ni++;
 	    }
 
+#ifdef	EXTRA_STATISTICS
+	switch (level) {
+	case 2:	now = timeofday - me.since;
+		if (now == 0)
+			now = 1;
+
+		sendto_one(cptr,
+    ":%s %d %s :------------------------------------------------------",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Current uptime: %4d day%s, %2d:%02d:%02d%s      %10d s",
+    ME, RPL_STATSDEBUG, name, now/86400, ( now/86400 == 1 ? "" : "s"),
+    (now/3600)%24, (now/60)%60, now%60, ( now/86400 == 1 ? " " : ""), now);
+		sendto_one(cptr,
+    ":%s %d %s :------------------------------------------------------",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Connected  Current  Highest  Average    Total  NetHigh",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Clients:   %6u %8u %8.1f %8u %8u",
+    ME, RPL_STATSDEBUG, name, istat.is_myclnt, istat.is_m_myclnt,
+    (float )((double ) sp->is_cti / (double ) (now)), sp->is_cl,
+    istat.is_m_users);
+		if (istat.is_m_myservice != 0)
+			sendto_one(cptr,
+	    ":%s %d %s :Services:  %6u %8u                   %8u",
+	    ME, RPL_STATSDEBUG, name, istat.is_myservice,
+	    istat.is_m_myservice, istat.is_m_service);
+		sendto_one(cptr,
+    ":%s %d %s :Servers:   %6u %8u %8.1f %8u %8u",
+    ME, RPL_STATSDEBUG, name, istat.is_myserv, istat.is_m_myserv,
+    ((float ) sp->is_sti / (float ) (now)), sp->is_sv, istat.is_m_serv);
+		sendto_one(cptr,
+    ":%s %d %s :------------------------------------------------------",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Duration         Average                       Total",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Clients:     %4d:%02d:%02d                %12lu s",
+    ME, RPL_STATSDEBUG, name,
+    ((sp->is_cti / (sp->is_cl ? sp->is_cl : 1))/3600),
+    (((sp->is_cti / (sp->is_cl ? sp->is_cl : 1))/60)%60),
+    ((sp->is_cti / (sp->is_cl ? sp->is_cl : 1))%60), sp->is_cti);
+		sendto_one(cptr,
+    ":%s %d %s :Servers:     %4d:%02d:%02d                %12lu s",
+    ME, RPL_STATSDEBUG, name,
+    ((sp->is_sti / (sp->is_sv ? sp->is_sv : 1))/3600),
+    (((sp->is_sti / (sp->is_sv ? sp->is_sv : 1))/60)%60),
+    ((sp->is_sti / (sp->is_sv ? sp->is_sv : 1))%60), sp->is_sti);
+		sendto_one(cptr,
+    ":%s %d %s :------------------------------------------------------",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Data received    Average       Rate           Total",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Clients:       %8lu Kb  %6.2f Kb/s %10lu Kb",
+    ME, RPL_STATSDEBUG, name, (sp->is_ckr / ( sp->is_cl ? sp->is_cl : 1 )),
+    ((double ) sp->is_ckr / (double ) (now)), sp->is_ckr);
+		sendto_one(cptr,
+    ":%s %d %s :Servers:       %8lu Kb  %6.2f Kb/s %10lu Kb",
+    ME, RPL_STATSDEBUG, name,
+    ( sp->is_skr / ( sp->is_sv ? sp->is_sv : 1 )),
+    (float )((double ) sp->is_skr / (double ) (now)), sp->is_skr);
+		sendto_one(cptr,
+    ":%s %d %s :UDP:           %8u",
+    ME, RPL_STATSDEBUG, name, sp->is_udpok);
+		sendto_one(cptr,
+    ":%s %d %s :------------------------------------------------------",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Data sent        Average       Rate           Total",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Clients:       %8lu Kb  %6.2f Kb/s %10lu Kb",
+    ME, RPL_STATSDEBUG, name, (sp->is_cks / (sp->is_cl ? sp->is_cl : 1)),
+    (float )((double ) sp->is_cks / (double ) (now)), sp->is_cks);
+		sendto_one(cptr,
+    ":%s %d %s :Servers:       %8lu Kb  %6.2f Kb/s %10lu Kb",
+    ME, RPL_STATSDEBUG, name, (sp->is_sks / (sp->is_sv ? sp->is_sv : 1)),
+    (float )((double ) sp->is_sks / (double ) (now)), sp->is_sks);
+		sendto_one(cptr,
+    ":%s %d %s :------------------------------------------------------",
+    ME, RPL_STATSDEBUG, name);
+		return;
+
+	case 1:	sendto_one(cptr,
+    ":%s %d %s :------------------------------------------------------",
+    ME, RPL_STATSDEBUG, name);
+#if !defined(USE_IAUTH)
+		sendto_one(cptr,
+    ":%s %d %s :Authorization fails:                         %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_abad);
+		sendto_one(cptr,
+    ":%s %d %s :Authorization successes:                     %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_asuc);
+#endif
+		sendto_one(cptr,
+    ":%s %d %s :Connections accepted:                        %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_ac);
+		sendto_one(cptr,
+    ":%s %d %s :Connections refused:                         %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_ref);
+		sendto_one(cptr,
+    ":%s %d %s :Local connections made:                      %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_loc);
+		sendto_one(cptr,
+    ":%s %d %s :------------------------------------------------------",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Fakes:                                       %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_fake);
+		sendto_one(cptr,
+    ":%s %d %s :Nick Collisions:                             %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_kill);
+	sendto_one(cptr,
+    ":%s %d %s :Unknown connections dropped:                 %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_ni);
+		sendto_one(cptr,
+    ":%s %d %s :Users without servers:                       %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_nosrv);
+		sendto_one(cptr,
+    ":%s %d %s :Empty messages:                              %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_empt);
+		sendto_one(cptr,
+    ":%s %d %s :Numerics seen:                               %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_num);
+		sendto_one(cptr,
+    ":%s %d %s :Unknown commands:                            %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_unco);
+		sendto_one(cptr,
+    ":%s %d %s :Unknown prefixes:                            %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_unpf);
+		sendto_one(cptr,
+    ":%s %d %s :Wrong directions:                            %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_wrdi);
+		sendto_one(cptr,
+    ":%s %d %s :------------------------------------------------------",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Elapsed time     Minimum   Average   Maximum     Limit",
+    ME, RPL_STATSDEBUG, name);
+		sendto_one(cptr,
+    ":%s %d %s :Nick Delay:    %8lu  %8lu  %8lu  %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_wwmt,
+    (u_int) (sp->is_wwt / (sp->is_wwcnt ? sp->is_wwcnt : 1 )),
+    sp->is_wwMt, KILLCHASETIMELIMIT);
+		sendto_one(cptr,
+    ":%s %d %s :Whowas:        %8lu  %8lu  %8lu  %8lu",
+    ME, RPL_STATSDEBUG, name, sp->is_lkmt,
+    (u_int) (sp->is_lkt / (sp->is_lkcnt ? sp->is_lkcnt : 1)),
+    sp->is_lkMt, DELAYCHASETIMELIMIT);
+		sendto_one(cptr,
+    ":%s %d %s :------------------------------------------------------",
+    ME, RPL_STATSDEBUG, name);
+#if defined(USE_IAUTH)
+	report_iauth_stats(cptr, name);
+		sendto_one(cptr,
+	":%s %d %s :------------------------------------------------------",
+	ME, RPL_STATSDEBUG, name);
+#endif
+		return;
+	}
+#endif
+
 	sendto_one(cptr, ":%s %d %s :accepts %lu refused %lu",
 		   ME, RPL_STATSDEBUG, name, sp->is_ac, sp->is_ref);
 	sendto_one(cptr, ":%s %d %s :unknown: commands %lu prefixes %lu",
@@ -939,6 +1252,13 @@
 		   sp->is_ckr, sp->is_cbr, sp->is_skr, sp->is_sbr);
 	sendto_one(cptr, ":%s %d %s :time connected %lu %lu",
 		   ME, RPL_STATSDEBUG, name, sp->is_cti, sp->is_sti);
+#ifdef DELAY_CLOSE
+        if (IsAnOper(cptr))
+        {
+                sendto_one(cptr, ":%s %d %s :delay closed %lu",
+                   ME,RPL_STATSDEBUG, name, istat.is_delayclosed);
+        }
+#endif
 #if defined(USE_IAUTH)
 	report_iauth_stats(cptr, name);
 #endif
@@ -995,4 +1315,340 @@
 	(void)dgets(-1, NULL, 0); /* make sure buffer is at empty pos */
 	close(fd);
 }     
+#endif
+
+
+#if defined(OPER_KLINE) || defined(LOCOP_KLINE)
+int	m_kline(cptr,sptr,parc,parv)
+aClient	*cptr, *sptr;
+int	parc;
+char	*parv[];
+{
+
+#if defined(OPER_KLINE) && defined(LOCOP_KLINE)
+	if (!MyClient(sptr) || !IsAnOper(sptr))
+#else
+#  if defined(OPER_KLINE)
+	if (!MyClient(sptr) || !IsOper(sptr))
+#  else
+	if (!MyClient(sptr) || !IsLocOp(sptr))
+#  endif
+#endif
+	    {
+		sendto_one(sptr, err_str(ERR_NOPRIVILEGES, parv[0]), me.name,
+		    parv[0]);
+		return 0;
+	    }
+
+	return m_dokline(cptr,sptr,parc,parv,1);
+}
+#endif
+
+
+#if defined(OPER_TKLINE) || defined(LOCOP_TKLINE)
+int	m_tkline(cptr,sptr,parc,parv)
+aClient	*cptr, *sptr;
+int	parc;
+char	*parv[];
+{
+
+#if defined(OPER_TKLINE) && defined(LOCOP_TKLINE)
+	if (!MyClient(sptr) || !IsAnOper(sptr))
+#else
+#  if defined(OPER_TKLINE)
+	if (!MyClient(sptr) || !IsOper(sptr))
+#  else
+	if (!MyClient(sptr) || !IsLocOp(sptr))
+#  endif
+#endif
+	   {
+		sendto_one(sptr, err_str(ERR_NOPRIVILEGES, parv[0]), me.name,
+		    parv[0]);
+		return 0;
+	    }
+
+	return m_dokline(cptr,sptr,parc,parv,0);
+}
+#endif
+
+
+#if defined(OPER_KLINE) || defined(LOCOP_KLINE) || \
+    defined(OPER_TKLINE) || defined(LOCOP_TKLINE)
+extern int kline_added;
+
+int	m_dokline(cptr, sptr, parc, parv, perm)
+aClient	*cptr, *sptr;
+int	parc;
+char	*parv[];
+int	perm;
+{
+	aConfItem	*aconf;
+	aClient		*acptr;
+	int		out, i;
+	char		buffer[1024];
+	char		*user, *host;
+	char		kline_reason[256];
+	time_t		current_time;
+
+	if (parc < 3)
+	    {
+		sendto_one(sptr, ":%s NOTICE %s :Not enough parameters",
+			me.name, parv[0]);
+		return 0;
+	    }
+
+	if (match("*@*", parv[1]))
+	    {
+		sendto_one(sptr,
+		":%s NOTICE %s :Sorry but \"%s\" needs to be of the format\
+ of user@host", me.name, parv[0], parv[1]);
+		return 0;
+	    }
+
+	user = parv[1];
+	while (*user)
+	    {
+		if ((*user == ' ') || (*user =='#') ||
+#ifdef INET6
+			(*user == '%')
+#else
+			(*user == ':')
+#endif
+			)
+			break;
+		user++;
+	    }
+
+	if (*user && (*user != ' '))
+	    {
+		sendto_one(sptr,
+		    ":%s NOTICE %s :The user@host may not contain '%c'",
+		    me.name, parv[0], *user);
+		return 0;
+	    }
+
+	host = strchr(parv[1], '@');
+	*(host++) = '\0';
+
+	if ((user = strchr(host, ' ')) != NULL)
+		*user = '\0';
+	user = parv[1];
+
+	if (!match(user, "dummyuser") && !match(host, "dumm.ystring.xx"))
+	    {
+		sendto_one(sptr,
+		    ":%s NOTICE %s :Sorry can not %skline *@*",
+		    me.name, parv[0], ( perm ? "" : "t" ));
+		return 0;
+	    }
+
+	kline_reason[0] = '\0';
+	if (isdigit(*parv[2]))
+	    {
+		sendto_one(sptr,
+		    ":%s NOTICE %s :The %skline reason may not start\
+ with a digit",
+		    me.name, parv[0], ( perm ? "" : "t" ));
+		return 0;
+	    }
+
+	for (i = 2; i < parc; i++)
+	    {
+		if (strlen(parv[i]) + strlen(kline_reason) + 2 < 256)
+		    {
+			strcat(kline_reason, parv[i]);
+			strcat(kline_reason, "\240");
+		    }
+	     }
+	kline_reason[strlen(kline_reason) - 1] = '\0';
+
+	for (i = strlen(kline_reason) - 1; i >= 0; i--)
+	    {
+		if ((kline_reason[i] == '#') || 
+#ifdef INET6
+			(kline_reason[i] == '%')
+#else
+			(kline_reason[i] == ':')
+#endif
+			)
+		    {
+			sendto_one(sptr,
+			    ":%s NOTICE %s :The %skline reason may not\
+ contain '%c'",
+			    me.name, parv[0], ( perm ? "" : "t" ),
+			    kline_reason[i]);
+			return 0;
+		    }
+		}
+
+	aconf = make_conf();
+	aconf->status = CONF_KILL;
+	DupString(aconf->host, host);
+	DupString(aconf->passwd, kline_reason);
+	DupString(aconf->name, user);
+	aconf->port = 0;
+	Class(aconf) = find_class(0);
+	aconf->next = kconf;
+	kconf = aconf;
+	aconf = NULL;
+
+	kline_added = 1;
+	rehashed    = 1;
+
+	if (perm)
+	    {
+		if ((out = open(KLINE_FILE, O_WRONLY|O_APPEND))==-1)
+		    {
+			sendto_one(sptr,
+			    ":%s NOTICE %s :Problem opening server configfile",
+			    me.name, parv[0]);
+			return 0;
+		    }
+
+		time(&current_time);
+
+		sprintf(buffer, "# Added by %s (%s@%s) on %s",
+			sptr->name, sptr->user->username, sptr->user->host,
+			asctime(localtime(&current_time)));
+		if (write(out, buffer, strlen(buffer)) <= 0)
+		    {
+			sendto_one(sptr,
+			":%s NOTICE %s :Problem writing to the configfile",
+			me.name, parv[0]);
+			close(out);
+			return 0;
+		    }
+
+#ifdef INET6
+		sprintf(buffer, "K%%%s%%%s%%%s%%\n\n", host, kline_reason, user);
+#else
+		sprintf(buffer, "K:%s:%s:%s:\n\n", host, kline_reason, user);
+#endif
+		if (write(out, buffer, strlen(buffer)) <= 0)
+		    {
+			sendto_one(sptr,
+			":%s NOTICE %s :Problem writing to the configfile",
+			me.name, parv[0]);
+			close(out);
+		        return 0;
+		    }
+		close(out);
+	    }
+
+	sendto_flag(SCH_LOCAL, "%s added a %skline for %s@%s with reason: %s",
+	    parv[0], ( perm ? "" : "t" ), user, host, kline_reason);
+	sendto_one(sptr, 
+	    ":%s NOTICE %s :Added %skline for %s@%s%s with reason: %s",
+	    me.name, parv[0], ( perm ? "" : "t" ), user, host,
+	    ( perm ? " to the server configfile" : "" ), kline_reason);
+#if defined(USE_SYSLOG) && defined(SYSLOG_KLINE)
+	syslog(LOG_INFO, "%s!%s@%s %skline %s@%s (%s)",
+		sptr->name, sptr->user->username, sptr->user->host,
+		( perm ? "" : "t" ), user, host, kline_reason);
+#endif
+
+
+	return 0;
+}
+#endif
+
+#ifdef EXTRA_STATISTICS
+static Link *saved_servers = NULL;
+void save_server_max(server,clients)
+char *server;
+int clients;
+{
+	Link *lp;
+	char *servername;
+
+	for (lp = saved_servers; lp ; lp = lp->next)
+	{
+		if (!mycmp(lp->value.cp,server))
+		{
+			sendto_flag(SCH_ERROR,"Tried to save server's user maximum for already saved server");
+			return;
+		}
+	}
+	
+	servername = mystrdup(server);
+	lp = make_link();
+	lp->value.cp = servername;
+	lp->flags = clients;
+	lp->next = saved_servers;
+	saved_servers = lp;
+}
+
+
+int restore_server_max(server)
+char *server;
+{
+	Link *lp, **curr;
+	int users = 0;
+	
+	for (curr = &saved_servers ; (lp = *curr); curr = &lp->next)
+	{
+		if (!mycmp(lp->value.cp,server))
+		{
+			users = lp->flags;
+			*curr = lp->next;
+			free_link(lp);
+			break;
+		}
+	}
+	return users; 
+}
+#endif
+
+#ifdef SPLIT_HANDLE
+void check_split()
+{
+	if (istat.is_eobservers < SPLIT_SERV ||
+	   (istat.is_user[0] + istat.is_user[1] < SPLIT_USERS))
+	{
+		if (!iconf.split)
+		{
+			sendto_flag(SCH_NOTICE,"Network split detected, split mode activated");
+		}
+		iconf.split = 1;
+	}
+	else
+	{
+		if (iconf.split)
+		{
+			sendto_flag(SCH_NOTICE,"Network rejoined, split mode deactivated");
+#ifdef DELAY_ACCEPT
+			if (iconf.caccept == 1)
+			{
+				activate_delayed_listeners();
+				iconf.caccept = 2;
+			}
+#endif
+		}
+		iconf.split = 0;
+
+	}
+	
+}
+void bubble_eob(sptr)
+aClient *sptr;
+{
+	aClient *acptr = sptr;
+	char *up = sptr->serv->up;
+	while (up && mycmp(up,me.name))
+	{
+		up = acptr->serv->up;
+		acptr = find_server(up,NULL);
+		if (!acptr)
+		{
+			sendto_flag(SCH_ERROR,"Unknown uplink %s while bubbling EOB ?!",up);
+			break;
+		}
+		if (IsBurst(acptr))
+		{
+			ClearBurst(acptr);
+			istat.is_eobservers++;
+			sendto_flag(SCH_DEBUG,"EOB from %s (bubbled)",up);
+		}
+	}
+}
 #endif
diff -Nur irc2.10.3p7/ircd/s_misc_ext.h irc2.10.3p7+hemp2+DK+B5/ircd/s_misc_ext.h
--- irc2.10.3p7/ircd/s_misc_ext.h	Mon Aug  3 16:09:23 1998
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_misc_ext.h	Tue May 11 15:25:04 2004
@@ -51,8 +51,27 @@
 			    char *comment));
 EXTERN void checklist();
 EXTERN void initstats();
+#ifdef	EXTRA_STATISTICS
+EXTERN void tstats __P((aClient *cptr, char *name, int level));
+#else
 EXTERN void tstats __P((aClient *cptr, char *name));
+#endif
 #ifdef  CACHED_MOTD
 EXTERN void read_motd __P((char *filename));
 #endif /* CACHED_MOTD */
+#if	defined(OPER_KLINE) || defined(LOCOP_KLINE)
+EXTERN int m_kline __P((aClient *cptr, aClient *sptr, int parc, char *parv[]));
+#endif
+#if	defined(OPER_TKLINE) || defined(LOCOP_TKLINE)
+EXTERN int m_tkline __P((aClient *cptr, aClient *sptr, int parc,
+    char *parv[]));
+#endif
+#ifdef EXTRA_STATISTICS
+EXTERN void save_server_max __P((char *server,int clients));
+EXTERN int restore_server_max __P((char *server));
+#endif
+#ifdef SPLIT_HANDLE
+EXTERN void check_split();
+EXTERN void bubble_eob __P((aClient *sptr));
+#endif
 #undef EXTERN
diff -Nur irc2.10.3p7/ircd/s_numeric.c irc2.10.3p7+hemp2+DK+B5/ircd/s_numeric.c
--- irc2.10.3p7/ircd/s_numeric.c	Sun Dec 13 00:48:17 1998
+++ irc2.10.3p7+hemp2+DK+B5/ircd/s_numeric.c	Tue May 11 15:25:04 2004
@@ -82,7 +82,8 @@
 	    }
 	for (; (nick = strtoken(&p, parv[1], ",")); parv[1] = NULL)
 	    {
-		if ((acptr = find_client(nick, (aClient *)NULL)))
+		if ((acptr = find_client(nick, (aClient *)NULL)) ||
+		     (acptr = find_server(nick, NULL)))
 		    {
 			/*
 			** Drop to bit bucket if for me...
@@ -96,11 +97,27 @@
 			** - Avalon
 			*/
 			if (IsMe(acptr) || acptr->from == cptr)
+			{
+#ifdef SPLIT_HANDLE
+				if (IsServer(sptr) && IsBurst(sptr) &&
+					numeric == ERR_NOSUCHSERVER)
+				{    /* we got EOB-emulation reply */
+					ClearBurst(sptr);
+					sendto_flag(SCH_DEBUG,"End of burst from %s (emulated)",sptr->name);
+					istat.is_eobservers++;
+					bubble_eob(sptr);
+					check_split();
+				}
+				else
+#endif
+				{
 				sendto_flag(SCH_NUM,
 					    "From %s for %s: %s %d %s %s.",
 					    get_client_name(cptr, TRUE),
 					    acptr->name, sptr->name,
 					    numeric, nick, buffer);
+				}
+			}
 			else if (IsPerson(acptr) || IsServer(acptr) ||
 				 IsService(acptr))
 				sendto_prefix_one(acptr, sptr,":%s %d %s%s",
